local colorUltimate = "|cFFE100"
local colorMenu = "|cF2C43A"
local settings = {
	counterZone = true,
	percentageZone = true,
	colorPercentage = {
		red = 255,
		blue = 255,
		green = 255,
		alpha = 255
	},
	colorCounter = {
		red = 255,
		blue = 255,
		green = 255,
		alpha = 255
	}
}

--Event function
function AddonOnLoad(eventCode, addonName)
	if addonName == "Ultimate" then
	
		settings = ZO_SavedVars:New("Ultimate_SavedVars", 1, nil, settings)
		InitMenu()
		UpdateUltimate()
		
		EVENT_MANAGER:RegisterForEvent("Ultimate", EVENT_POWER_UPDATE, PowerUpdate)
		EVENT_MANAGER:RegisterForEvent("Ultimate", EVENT_ACTION_SLOTS_FULL_UPDATE, SlotUpdate)
	end
end

function PowerUpdate(eventCode, unitTag, powerIndex, powerType, powerValue, powerMax, powerEffectiveMax)
	if  powerType == POWERTYPE_ULTIMATE then
		UpdateUltimate()
	end
end

function SlotUpdate(eventCode, slotNum)
	if  slotNum == ACTION_SLOT_TYPE_ULTIMATE then
		UpdateUltimate()
	end
end
--Event function!

--Menu
function InitMenu()
	local LAM = LibStub:GetLibrary("LibAddonMenu-1.0")
	local controlName = "UltimateCounter"
	local panelID = LAM:CreateControlPanel(controlName.."1", "Ultimate "..colorUltimate.."Counter")
	
	LAM:AddHeader(panelID, controlName.."2", colorMenu.."Percentage Settings")
	LAM:AddCheckbox(panelID,
					controlName.."3",
					"Display percentage",
					"",
					function()
						return settings.percentageZone
					end,
					function(state)
						settings.percentageZone = state
						UpdateUltimate()
					end)
	LAM:AddColorPicker(panelID,
					   controlName.."4",
					   "Percentage color",
					   "",
					   function()
					       return settings.colorPercentage.red, settings.colorPercentage.green, settings.colorPercentage.blue, settings.colorPercentage.alpha 
					   end,
					   function(r, g, b, a)
					       settings.colorPercentage.red = r
					       settings.colorPercentage.green = g
					       settings.colorPercentage.blue = b
					       settings.colorPercentage.alpha = a
						   UpdateUltimate()
					   end)

	LAM:AddHeader(panelID, controlName.."5", colorMenu.."Counter Settings")
	LAM:AddCheckbox(panelID,
					controlName.."6",
					"Display counter",
					"",
					function()
						return settings.counterZone
					end,
					function(state)
						settings.counterZone = state
						UpdateUltimate()
					end)
	LAM:AddColorPicker(panelID,
					   controlName.."7",
					   "Counter color",
					   "",
					   function()
					       return settings.colorCounter.red, settings.colorCounter.green, settings.colorCounter.blue, settings.colorCounter.alpha 
					   end,
					   function(r, g, b, a)
					       settings.colorCounter.red = r
					       settings.colorCounter.green = g
					       settings.colorCounter.blue = b
					       settings.colorCounter.alpha = a
						   UpdateUltimate()
					   end)
end
--Menu!

--Update Ultimate Counter and Percentage
function UpdateUltimate()
	ULT_CURRENT, ULT_MAX = GetUnitPower("player", POWERTYPE_ULTIMATE)
	ULT_COST, mechanic = GetSlotAbilityCost(8)
	
	if ULT_COST > 0 then
		UpdateUltimateCounter(ULT_CURRENT, ULT_COST)
		UpdateUltimatePercentage(ULT_CURRENT, ULT_COST)
	end
end

function UpdateUltimatePercentage(ULT_CURRENT, ULT_COST)
	local ULT_Percentage = (ULT_CURRENT / ULT_COST)*100
	
	Ultimate_Zone2_Percentage:SetText(string.format("%.0f%%", ULT_Percentage))
	
	if settings.percentageZone == true then 
		Ultimate_Zone2_Percentage:SetColor(settings.colorPercentage.red, settings.colorPercentage.green, settings.colorPercentage.blue, settings.colorPercentage.alpha)
	end
	if settings.percentageZone == false then 
		Ultimate_Zone2_Percentage:SetColor(0, 0, 0, 0)
	end
	
end

function UpdateUltimateCounter(ULT_CURRENT, ULT_COST)
	Ultimate_Zone1_Counter:SetText(string.format("%d / %d", ULT_CURRENT, ULT_COST))
	
	if settings.counterZone == true then 
		Ultimate_Zone1_Counter:SetColor(settings.colorCounter.red, settings.colorCounter.green, settings.colorCounter.blue, settings.colorCounter.alpha)
	end
	if settings.counterZone == false then 
		Ultimate_Zone1_Counter:SetColor(0, 0, 0, 0)
	end
	
end
--Update Ultimate Counter and Percentage!

--Event function
EVENT_MANAGER:RegisterForEvent("Ultimate", EVENT_ADD_ON_LOADED, AddonOnLoad)
--Event function!